// 为了避免函数、对象以及变量和jQuery其他的函数、对象及变量冲突，所有方法都以Umss结束
;(function($){
	var emailregex = /^([a-zA-Z0-9_-]{1,})((.[a-zA-Z0-9_-]{1,}){0,})@([a-zA-Z0-9_-]{1,})((.[a-zA-Z0-9_-]{1,}){1,})$/,
		mphoneregex = /^1[3|4|5|8][0-9]\d{4,8}$/,
		pwdregex = /^[a-zA-Z0-9]{6,32}$/;
		
	$.extend({
		'umsscode':'',
		'isEmailUmss':function(val){
			return emailregex.test(val);
		},
		'isMPhoneUmss':function(val){
			return mphoneregex.test(val);
		},
		'isPwdLengthMinUmss':function(val){
			return (val.length < 6)?true:false;
		},
		'isPwdLengthMaxUmss':function(val){
			return (val.length > 32)?true:false;
		},
		'pwdFormatCheckUmss':function(val){ 
			return !pwdregex.test(val);
		},
		'createUmssCode':function(jobj){
			$.umsscode = '';
			var codelen = 6;//验证码的长度
			var selectChar = new Array(0,1,2,3,4,5,6,7,8,9,'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');//所有候选组成验证码的字符，当然也可以用中文的
			for (var i = 0;i < codelen;i++){
				var charindex = Math.floor(Math.random()*36);
				$.umsscode += selectChar[charindex];	
			}
			jobj.val($.umsscode);
		},
		'bindEvtByTypeUmss':function(formattrs,evttypes,evtMethods){
			$.each(formattrs,function(ind,obj){
				$(obj).bind(evttypes,function(evt){
					var type = evt.type;
					switch(type){
						case 'blur':
							evtMethods.blur(evt);
						break;
						case 'focus':
							evtMethods.focus(evt);
						break;
						case 'keyup':
							evtMethods.keyup(evt);
						break;
						case 'click':
							evtMethods.click(evt);
						break;
						default:
						break;	
					}
				});
			});				
		}
	});
})(jQuery)