;(function($){
	$.xjcopy = $.fn.xjcopy = function(){
		// options是用来存储拷贝对象的源对象的临时变量，name是拷贝对象的属性值
		// src 用来存储拷贝对象目标的值，copy存储被拷贝对象的目标值比如我们示例代码
		// 里的 src = targetobj['id'],copy = targetobj['id']
		// copyIsArray是个布尔值，用来存储对象是不是数组的标记
		// clone是作为合并的的临时对象（这个大家看深拷贝的代码慢慢体会了）
		// target这个是我们的extend参数的target
		// i是extend参数objectN在arguments里的索引值
		// length是指参数个数，deep深浅拷贝的标记，大家可以看到默认下deep是false
		var options, name, src, copy, copyIsArray, clone,
			target = arguments[0] || {},
			i = 1,
			length = arguments.length,
			deep = false;
	
		// 如果第一个参数是布尔值，那么这是用户在设定是否要进行深浅拷贝
		if (length >2){
			if (deep === false || deep === true){
				deep = target;//设定deep的值，这个好理解
				target = arguments[1] || {};//如果设定deep属性，那么target要重新赋值
				// 如果第一个参数设置的深浅拷贝标记，那么i设为2，表明arguments的objectN参数是从索引为2的值开始
				i = 2;				
			}
		}
		
		/*if ( typeof target === "boolean") {
			deep = target;//设定deep的值，这个好理解
			target = arguments[1] || {};//如果设定deep属性，那么target要重新赋值
			// 如果第一个参数设置的深浅拷贝标记，那么i设为2，表明arguments的objectN参数是从索引为2的值开始
			i = 2;
		}*/
	
		// 如果传入的不是对象或者是函数，可能为字符串，那么把target = {}置为空对象
		// extend最终返回值是target，我们看到target在方法里都是被设置为对象，所以不管我们传什么样的
		// 的参数到extend方法里，最终结果都是object类型，这也说明如果objectN参数是对象，extend同样会做合并操作
		// 如果objectN非object类型那么下面深浅拷贝操作也就没意义了
		if ( typeof target !== "object" && !$.isFunction(target) ) {
			target = {};
		}
	
		// 如果传入的参数只有一个，跳过下面的步骤
		// 当参数只有一个时候，target被设置为this，这里就是关键所在，这里的解释我要写在文档里
		if ( length === i ) {
			target = this;
			--i;
		}	
		
		// 下面的代码就是javascript里做深浅拷贝的代码，这个和我们前面自己写的深浅拷贝的代码类似
		for ( ; i < length; i++ ) {
			// 只操作对象值非null/undefined的数据
			if ( (options = arguments[i]) != null ) {
				for ( name in options ) {
					src = target[ name ];
					copy = options[ name ];
	
					// 避免死循环，这个和我写的深拷贝的代码类似
					if ( target === copy ) {
						continue;
					}
	
					// 通过递归的方式我们把对象和数组类型的数据合并起来
					if ( deep && copy && ( $.isPlainObject(copy) || (copyIsArray = $.isArray(copy)) ) ) {
						if ( copyIsArray ) {
							copyIsArray = false;
							clone = src && $.isArray(src) ? src : [];
	
						} else {
							clone = src && $.isPlainObject(src) ? src : {};
						}
	
						// 不去改变原始对象，只是对原始对象做拷贝操作
						target[ name ] = $.xjcopy( deep, clone, copy );
	
					} else if ( copy !== undefined ) {
						target[ name ] = copy;
					}
				}
			}
		}
		// 返回结果
		return target;	
	};
})(jQuery)