(function(window, undefined) {
	// 将经常使用的全局对象重新定义在自己写好的封闭作用域内是提高你代码速度以及质量的一致方式
	// 因为在javascript这种语言里局部变量的效率永远都是高于全局变量的
	var document = window.document,navigator = window.navigator,location = window.location;
	
	var xQuery = (function(){
		
		// 我们在定义xQuery里面再定义一个xQuery对象，这个技巧也是把构建jQuery的代码封装到
		// 一个独立的封闭作用域里，这个作用域和插件技术里的xQuery区别开来，从而提升了在定义
		// xQuery时候的代码效率
		var xQuery = function(selector,context){
			return new xQuery.fn.init();
		};
		
		// xQuery.fn是xQuery.prototype的别名
		xQuery.fn = xQuery.prototype = {
			init:function(){
				this.length = 0;
				this.test = function(){
					return this.length;	
				}
				return this;
			},
			xquery:'1.0.0',
			length:1,
			size:function(){
				return this.length;	
			}
		};
		
		//xQuery.fn.init.prototype = xQuery.fn; // 使用xQuery的原型对象覆盖init的原型对象
		
		return xQuery;
		
	})();
	
	window.xQuery = window.$ = xQuery;
})(window);